// JavaScript Document
var _startX = 0; // mouse starting positions 
var _startY = 0; 
var _offsetX = 0; // current element offset 
var _offsetY = 0; 
var _dragElement; // needs to be passed from OnMouseDown to OnMouseMove 
var _dropBoxes=[];//set to the elements that accept dragged objects on them; they must have onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"
var _boundingBox=null;//set to the element defining the bounding box for the drag. must have onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"
var _retElement,_returnElementInterval,_retDx,_retDy,_retStep;
function doDrop(elem,box){return game.UI.drop(elem,box);}//set to process the event of dropping an element in a box - return false if wrong destination
InitDragDrop(); function InitDragDrop() { document.onmousedown = OnMouseDown; document.onmouseup = OnMouseUp; }
function ExtractNumber(value) { var n = parseInt(value); return n == null || isNaN(n) ? 0 : n; }
function OnMouseDown(e)
{
	// IE is retarded and doesn't pass the event object
	if (e == null) 
		e = window.event; 
	
	// IE uses srcElement, others use target
	var target = e.target != null ? e.target : e.srcElement;
	var draggable=false;
	if(target.className.indexOf('dragContainer')>=0)draggable=true;else	if(target.className.indexOf('dragChild')>=0){
		while(target){
			if(target.className.indexOf('dragContainer')>=0){draggable=true;break;}
			target=target.parentNode;
		}
	}
	

	// for IE, left click == 1
	// for Firefox, left click == 0
	if ((e.button == 1 && window.event != null || e.button == 0) && draggable)
	{
		// grab the mouse position
		_startX = e.clientX;
		_startY = e.clientY;
		
		// grab the clicked element's position
		_offsetX = ExtractNumber(target.style.left);
		_offsetY = ExtractNumber(target.style.top);
		
		// bring the clicked element to the front while it is being dragged
		
		// we need to access the element in OnMouseMove
		_dragElement = target;

		// tell our code to start moving the element with the mouse
		document.onmousemove = OnMouseMove;
		
		// cancel out any text selections
		document.body.focus();
		
		// prevent text selection in IE
		document.onselectstart = function () { return false; };
		// prevent IE from trying to drag an image
		target.ondragstart = function() { return false; };
		
		// prevent text selection (except IE)
		return false;
	}
}

function OnMouseMove(e)
{
	
	if (e == null) 
		var e = window.event; 

	// this is the actual "drag code"
	var x = (_offsetX + e.clientX - _startX) + 'px';
	var y = (_offsetY + e.clientY - _startY) + 'px';
	if(_boundingBox.mouseOver){
		_dragElement.style.left =x;
		_dragElement.style.top =y;
	}/*else{
		_retElement=_dragElement;
		_retDx=(ExtractNumber(_dragElement.style.left)-_offsetX)/5;
		_retDy=(ExtractNumber(_dragElement.style.top)-_offsetY)/5;
		_retStep=0;
		_returnElementInterval=setInterval(returnDragElement,30);
		document.onmousemove = null;
		document.onselectstart = null;
		_dragElement.ondragstart = null;
		_dragElement = null;
	}*/
}

function OnMouseUp(e)
{
	var onBox=false,returnPad;
	if (_dragElement != null)
	{
	console.log(_boundingBox.mouseOver);
		for(var i=0;i<_dropBoxes.length;i++)if(_dropBoxes[i].mouseOver){
			onBox=true;
			if(!doDrop(_dragElement,_dropBoxes[i])){//return the dragged element to it's original position
				_retElement=_dragElement;
				_retDx=(ExtractNumber(_dragElement.style.left)-_offsetX)/5;
				_retDy=(ExtractNumber(_dragElement.style.top)-_offsetY)/5;
				_retStep=0;
				_returnElementInterval=setInterval(returnDragElement,30);
			}
		}
		if(!onBox || !_boundingBox.mouseOver){
			returnPad=document.getElementById('boxesUnderBox');
			if((returnPad && returnPad.mouseOver)||(!_boundingBox.mouseOver)){
				_retElement=_dragElement;
				_retDx=(ExtractNumber(_dragElement.style.left)-_offsetX)/5;
				_retDy=(ExtractNumber(_dragElement.style.top)-_offsetY)/5;
				_retStep=0;
				_returnElementInterval=setInterval(returnDragElement,30);
			}
		}

		// we're done with these events until the next OnMouseDown
		document.onmousemove = null;
		document.onselectstart = null;
		_dragElement.ondragstart = null;

		// this is how we know we're not dragging
		_dragElement = null;
	}
}

function returnDragElement(){
	_retElement.style.left=(ExtractNumber(_retElement.style.left)-_retDx)+'px';
	_retElement.style.top=(ExtractNumber(_retElement.style.top)-_retDy)+'px';
	_retStep++;
	if(_retStep>=5){
		clearInterval(_returnElementInterval);
	}
}
